diff -cNr ivtools-0.6.orig/src/Unidraw/psview.c ivtools-0.6/src/Unidraw/psview.c
*** ivtools-0.6.orig/src/Unidraw/psview.c	Wed Jan 21 10:06:29 1998
--- ivtools-0.6/src/Unidraw/psview.c	Wed Jan 28 20:32:14 1998
***************
*** 47,52 ****
--- 47,53 ----
  
  static const int MAXLINELEN = 256;
  
+ #ifndef JIV
  static char* reencodeISO[] = {
      "/reencodeISO {",
      "dup dup findfont dup length dict begin",
***************
*** 88,93 ****
--- 89,159 ----
      "] def",
      nil
  };
+ #else /* JIV */
+ /* Composite Font patch's PS part is written by */
+ /* Shigeru Chiba (chiba@is.s.u-tokyo.ac.jp) */
+ static char* reencodeISO[] = {
+     "% reencodeISO was modified to deal with a composite font correctly.",
+     "% Modifier: Shigeru Chiba (chiba@is.s.u-tokyo.ac.jp)",
+     "%           Kazuhiro Kazama (kazama@expert-sun.ntt.jp)",
+     "/reencodeISOa {		% CompFontName font reencodeISOb font' ",
+     "dup length dict begin",
+     "{ 1 index /FID ne { def }{ pop pop } ifelse } forall",
+     "/Encoding ISOLatin1Encoding def",
+     "currentdict end definefont",
+     "} def",
+     "",
+     "/reencodeISO {		% FontName reencodeISO font",
+     "    dup dup findfont dup /FontType get 0 ne {",
+     "    reencodeISOa",
+     "}{",
+     "    dup length dict begin {",
+     "    1 index dup /FID eq {",
+     "	pop pop pop",
+     "    }{ /FDepVector eq {",
+     "	dup length array copy",
+     "	dup dup 0 get 4 index exch reencodeISOa	0 exch put def",
+     "    }{",
+     "	def",
+     "    } ifelse } ifelse } forall",
+     "    currentdict end definefont",
+     "} ifelse } def",
+     "",
+     "/ISOLatin1Encoding [",
+     "/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef",
+     "/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef",
+     "/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef",
+     "/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef",
+     "/space/exclam/quotedbl/numbersign/dollar/percent/ampersand/quoteright",
+     "/parenleft/parenright/asterisk/plus/comma/minus/period/slash",
+     "/zero/one/two/three/four/five/six/seven/eight/nine/colon/semicolon",
+     "/less/equal/greater/question/at/A/B/C/D/E/F/G/H/I/J/K/L/M/N",
+     "/O/P/Q/R/S/T/U/V/W/X/Y/Z/bracketleft/backslash/bracketright",
+     "/asciicircum/underscore/quoteleft/a/b/c/d/e/f/g/h/i/j/k/l/m",
+     "/n/o/p/q/r/s/t/u/v/w/x/y/z/braceleft/bar/braceright/asciitilde",
+     "/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef",
+     "/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef/.notdef",
+     "/.notdef/dotlessi/grave/acute/circumflex/tilde/macron/breve",
+     "/dotaccent/dieresis/.notdef/ring/cedilla/.notdef/hungarumlaut",
+     "/ogonek/caron/space/exclamdown/cent/sterling/currency/yen/brokenbar",
+     "/section/dieresis/copyright/ordfeminine/guillemotleft/logicalnot",
+     "/hyphen/registered/macron/degree/plusminus/twosuperior/threesuperior",
+     "/acute/mu/paragraph/periodcentered/cedilla/onesuperior/ordmasculine",
+     "/guillemotright/onequarter/onehalf/threequarters/questiondown",
+     "/Agrave/Aacute/Acircumflex/Atilde/Adieresis/Aring/AE/Ccedilla",
+     "/Egrave/Eacute/Ecircumflex/Edieresis/Igrave/Iacute/Icircumflex",
+     "/Idieresis/Eth/Ntilde/Ograve/Oacute/Ocircumflex/Otilde/Odieresis",
+     "/multiply/Oslash/Ugrave/Uacute/Ucircumflex/Udieresis/Yacute",
+     "/Thorn/germandbls/agrave/aacute/acircumflex/atilde/adieresis",
+     "/aring/ae/ccedilla/egrave/eacute/ecircumflex/edieresis/igrave",
+     "/iacute/icircumflex/idieresis/eth/ntilde/ograve/oacute/ocircumflex",
+     "/otilde/odieresis/divide/oslash/ugrave/uacute/ucircumflex/udieresis",
+     "/yacute/thorn/ydieresis",
+     "] def",
+     nil
+ };
+ #endif /* JIV */
+ 
  
  /*****************************************************************************/
  
***************
*** 138,143 ****
--- 204,249 ----
  
      Comments(out);
      Prologue(out);
+ #ifdef PS_FIX
+     out << "%%EndProlog\n\n";
+     out << "%%BeginSetup\n";
+     out << "IdrawDict begin\n";
+     /// Out composite font information
+     UList* fonts = GetPSFonts();
+     out << PSCompositeFont::getPreamble() << "\n";
+     for (UList* u = fonts->First(); u != fonts->End(); u = u->Next()) {
+ 	PSFont* font = GetFont(u);
+ 
+ 	if (font->isComposite()) {
+ 	    const PSCompositeFont* pscmpf;
+ 	    pscmpf= PSCompositeFont::findFont(font->GetPrintFont());
+ 	    if (pscmpf != NULL) {
+ 		PSSlantFont* sf = 
+ 		    PSSlantFont::findFont(pscmpf->getKanjiFontName());
+ 		if (sf && (sf->printFlag() == false)) {
+ 		    out << "/" << sf->getFontName() << "\n";
+ 		    out << "    /" << sf->getOriginalFontName();
+ 		    out << " .2 slantfont definefont pop\n";
+ 		    sf->printFlag(true);
+ 		}
+ 
+ 		out << "/" << font->GetPrintFont() << "\n";
+ 		out << "    /" << pscmpf->getAsciiFontName();
+ 		out << " /" << pscmpf->getKanjiFontName();
+ 		out << " compositefont definefont pop\n";
+ 	    }
+ 	}
+ 	// No way to check if the X font's encoding is iso8859-1, so...
+ 	if (strncmp(font->GetPrintFont(), "Symbol", 6) != 0) {
+ 	    out << "/" << font->GetPrintFont() << " reencodeISO def\n";
+ 	} else {
+ 	    out << "/" << font->GetPrintFont() << " dup findfont def\n";
+ 	}
+     }
+     PSSlantFont::resetPrintFlag();
+ 
+     out << "%%EndSetup\n\n";
+ #endif
      Version(out);
      GridSpacing(out);
  
***************
*** 186,191 ****
--- 292,300 ----
  }
  
  void PostScriptView::Prologue (ostream& out) {
+ #ifdef JIV
+     CmpFontProcs(out);
+ #endif
      ConstProcs(out);
      BeginProc(out);
      EndProc(out);
***************
*** 193,199 ****
--- 302,310 ----
      ObjectProcs(out);
      MiscProcs(out);
  
+ #ifndef PS_FIX
      out << "%%EndProlog\n\n";
+ #endif
  }
  
  static int Count (UList* list) {
***************
*** 205,210 ****
--- 316,385 ----
      return i;
  }
  
+ #ifdef JIV
+ void PostScriptView::CmpFontProcs (ostream& out) {
+     out << "%%BeginProcSet: cmpfont.ps 1 2\n";
+     out << "% composite fonts for ASCII-EUC mixed string\n";
+     out << "% Version 1.2 1/31/1990\n";
+     out << "% Author Ken'ichi HANDA (handa@etl.go.jp)\n";
+     out << "% Anyone can freely copy, modify, distribute this program.\n";
+     out << "/copyfont {	% font-dic extra-entry-count  copyfont  font-dic\n";
+     out << "	1 index maxlength add dict begin\n";
+     out << "	{	1 index /FID ne 2 index /UniqueID ne and\n";
+     out << "		{def} {pop pop} ifelse\n";
+     out << "	} forall\n";
+     out << "	currentdict\n";
+     out << "	end\n";
+     out << "} bind def\n";
+     out << "\n";
+     out << "/compositefont {	% ASCIIFontName EUCFontName  compositefont  font'\n";
+     out << "    findfont dup /FontType get 0 eq {\n";
+     out << "	12 dict begin\n";
+     out << "	    1 copyfont dup begin\n";
+     out << "		/Encoding Encoding\n";
+     out << "		FMapType dup 2 eq {\n";
+     out << "		    pop 128 128\n";
+     out << "		}{\n";
+     out << "		    5 eq {\n";
+     out << "			256 256\n";
+     out << "		    }{\n";
+     out << "			/compositefont errordict /invalidfont get exec\n";
+     out << "		    } ifelse\n";
+     out << "		} ifelse\n";
+     out << "		getinterval def\n";
+     out << "	    end\n";
+     out << "	    /eucfont exch definefont\n";
+     out << "	    exch\n";
+     out << "	    findfont 1 copyfont dup begin\n";
+     out << "		/FontMatrix FontMatrix [1 0 0 1 0 0.05] matrix concatmatrix def\n";
+     out << "	    end\n";
+     out << "	    /asciifont exch definefont\n";
+     out << "	    exch\n";
+     out << "	    /FDepVector [ 4 2 roll ] def\n";
+     out << "	    /FontType 0 def\n";
+     out << "	    /WMode 0 def\n";
+     out << "	    /FMapType 4 def\n";
+     out << "	    /FontMatrix matrix def\n";
+     out << "	    /Encoding [0 1] def\n";
+     out << "	    /FontBBox {0 0 0 0} def\n";
+     out << "	    currentdict\n";
+     out << "	end\n";
+     out << "    }{\n";
+     out << "	pop findfont 0 copyfont\n";
+     out << "    } ifelse\n";
+     out << "} def	\n";
+     out << "\n";
+     out << "/slantfont {	% FontName slant-degree  slantfont  font'\n";
+     out << "    exch findfont 1 copyfont begin\n";
+     out << "    [ 1 0 4 -1 roll 1 0 0 ] FontMatrix exch matrix concatmatrix\n";
+     out << "    /FontMatrix exch def\n";
+     out << "    currentdict\n";
+     out << "    end\n";
+     out << "} def\n";
+     out << "%%EndProcSet\n\n";
+ }
+ #endif /* JIV */
+ 
  void PostScriptView::ConstProcs (ostream& out) {
      UList* fonts = GetPSFonts();
      int nfonts = Count(fonts);
***************
*** 212,222 ****
--- 387,402 ----
      out << "/IdrawDict " << (50 + nfonts) << " dict def\n";
      out << "IdrawDict begin\n\n";
  
+ #ifdef PS_FIX
+     IdrawDictPreamble(out);
+ #endif
+ 
      if (nfonts > 0) {
  	for (char** line = reencodeISO; *line != nil; ++line) {
  	    out << *line << "\n";
  	}
  
+ #ifndef PS_FIX
  	for (UList* u = fonts->First(); u != fonts->End(); u = u->Next()) {
  	    PSFont* font = GetFont(u);
  
***************
*** 227,232 ****
--- 407,413 ----
  		out << "/" << font->GetPrintFont() << " dup findfont def\n";
  	    }
  	}
+ #endif
  	out << "\n";
      }
  
***************
*** 925,930 ****
--- 1106,1146 ----
      for (UList* u = fonts->First(); u != fonts->End(); u = u->Next()) {
  	PSFont* font = GetFont(u);
  
+ #ifdef JIV
+ 	const PSCompositeFont* pscmpf;
+ 
+ 	if (font->isComposite() &&
+ 	    (pscmpf =
+ 	     PSCompositeFont::findFont(font->GetPrintFont()))) {
+ 
+ 	    const char* fa = pscmpf->getAsciiFontName();
+ 	    const char* fk = pscmpf->getKanjiFontName();
+ 	    PSSlantFont* sf = PSSlantFont::findFont(fk);
+ 	    if (sf) {
+ 		fk = sf->getOriginalFontName();
+ 	    }
+ 
+ 	    if (linelen + strlen(fa) + 2 <= MAXLINELEN) {
+ 		out << " ";
+ 		++linelen;
+ 	    } else {
+ 		out << "\n%%+ ";
+ 		linelen = strlen("%%+ ");
+ 	    }
+ 	    out << fa;
+ 	    linelen += strlen(fa);
+ 
+ 	    if (linelen + strlen(fk) + 2 <= MAXLINELEN) {
+ 		out << " ";
+ 		++linelen;
+ 	    } else {
+ 		out << "\n%%+ ";
+ 		linelen = strlen("%%+ ");
+ 	    }
+ 	    out << fk;
+ 	    linelen += strlen(fk);
+ 	} else {
+ #endif /* JIV */
  	if (linelen + strlen(font->GetPrintFont()) + 2 <= MAXLINELEN) {
  	    out << " ";
  	    ++linelen;
***************
*** 934,940 ****
--- 1150,1162 ----
  	}
  	out << font->GetPrintFont();
  	linelen += strlen(font->GetPrintFont());
+ #ifdef JIV
+ 	}
+ #endif /* JIV */
      }
+ #ifdef JIV
+     PSSlantFont::resetPrintFlag();
+ #endif
      out << "\n";
  }
  
***************
*** 986,991 ****
--- 1208,1253 ----
  
      Comments(out);
      Prologue(out);
+ #ifdef PS_FIX
+     out << "%%EndProlog\n\n";
+     out << "%%BeginSetup\n";
+     out << "IdrawDict begin\n";
+     /// Out composite font information
+     UList* fonts = GetPSFonts();
+     out << PSCompositeFont::getPreamble() << "\n";
+     for (UList* u = fonts->First(); u != fonts->End(); u = u->Next()) {
+ 	PSFont* font = GetFont(u);
+ 
+ 	if (font->isComposite()) {
+ 	    const PSCompositeFont* pscmpf;
+ 	    pscmpf= PSCompositeFont::findFont(font->GetPrintFont());
+ 	    if (pscmpf != NULL) {
+ 		PSSlantFont* sf = 
+ 		    PSSlantFont::findFont(pscmpf->getKanjiFontName());
+ 		if (sf && (sf->printFlag() == false)) {
+ 		    out << "/" << sf->getFontName() << "\n";
+ 		    out << "    /" << sf->getOriginalFontName();
+ 		    out << " .2 slantfont definefont pop\n";
+ 		    sf->printFlag(true);
+ 		}
+ 
+ 		out << "/" << font->GetPrintFont() << "\n";
+ 		out << "    /" << pscmpf->getAsciiFontName();
+ 		out << " /" << pscmpf->getKanjiFontName();
+ 		out << " compositefont definefont pop\n";
+ 	    }
+ 	}
+ 	// No way to check if the X font's encoding is iso8859-1, so...
+ 	if (strncmp(font->GetPrintFont(), "Symbol", 6) != 0) {
+ 	    out << "/" << font->GetPrintFont() << " reencodeISO def\n";
+ 	} else {
+ 	    out << "/" << font->GetPrintFont() << " dup findfont def\n";
+ 	}
+     }
+     PSSlantFont::resetPrintFlag();
+ 
+     out << "%%EndSetup\n\n";
+ #endif
      Version(out);
      GridSpacing(out);
  
diff -cNr ivtools-0.6.orig/src/Unidraw/stateviews.c ivtools-0.6/src/Unidraw/stateviews.c
*** ivtools-0.6.orig/src/Unidraw/stateviews.c	Wed Jan 21 09:28:04 1998
--- ivtools-0.6/src/Unidraw/stateviews.c	Wed Jan 28 20:32:14 1998
***************
*** 55,60 ****
--- 55,68 ----
  static const char* NONE = "None";
  static const char* UNNAMED = "[unnamed]";
  
+ #ifdef JIV_EXTEND
+ static const char* tmpLabel;
+ 
+ #define getLabel(attr, default) \
+     (((tmpLabel = unidraw->GetCatalog()->GetAttribute(attr)) != NULL) ? \
+      tmpLabel : default)
+ #endif
+ 
  /*****************************************************************************/
  
  class TextInteractor : public Interactor {
***************
*** 138,144 ****
      const char* text = ((TextInteractor*) interior())->GetText();
  
      return 
!         (name == nil && strcmp(text, UNNAMED) != 0) ||
          (name != nil && strcmp(text, name) != 0);
  }
  
--- 146,158 ----
      const char* text = ((TextInteractor*) interior())->GetText();
  
      return 
!         (name == nil && strcmp(text,
! #ifndef JIV_EXTEND
! 			       UNNAMED
! #else
! 			       getLabel("LUnnamedMark", UNNAMED)
! #endif
! 			       ) != 0) ||
          (name != nil && strcmp(text, name) != 0);
  }
  
***************
*** 147,153 ****
      TextInteractor* t = (TextInteractor*) interior();
      
      if (name == nil) {
!         t->SetText(UNNAMED);
      } else {
          t->SetText(name);
      }
--- 161,173 ----
      TextInteractor* t = (TextInteractor*) interior();
      
      if (name == nil) {
!         t->SetText(
! #ifndef JIV_EXTEND
! 		   UNNAMED
! #else
! 		   getLabel("LUnnamedMark", UNNAMED)
! #endif
! 		   );
      } else {
          t->SetText(name);
      }
***************
*** 169,175 ****
      TextInteractor* t = (TextInteractor*) interior();
      
      if (name == nil) {
!         t->SetText(UNNAMED);
  
      } else if (_relative) {
          const char* relname = strrchr(name, '/');
--- 189,201 ----
      TextInteractor* t = (TextInteractor*) interior();
      
      if (name == nil) {
!         t->SetText(
! #ifndef JIV_EXTEND
! 		   UNNAMED
! #else
! 		   getLabel("LUnnamedMark", UNNAMED)
! #endif
! 		   );
  
      } else if (_relative) {
          const char* relname = strrchr(name, '/');
***************
*** 201,207 ****
      TextInteractor* t = (TextInteractor*) interior();
      
      if (name == nil) {
!         t->SetText(UNNAMED);
  
      } else {
          char buf[CHARBUFSIZE];
--- 227,239 ----
      TextInteractor* t = (TextInteractor*) interior();
      
      if (name == nil) {
!         t->SetText(
! #ifndef JIV_EXTEND
! 		   UNNAMED
! #else
! 		   getLabel("LUnnamedMark", UNNAMED)
! #endif
! 		   );
  
      } else {
          char buf[CHARBUFSIZE];
***************
*** 287,300 ****
      char buf[32];
  
      _prevVal = mag;
      sprintf(buf, "mag %gx", mag);
      t->SetText(buf);
  }
  
  /*****************************************************************************/
  
  GravityVarView::GravityVarView (GravityVar* m, Alignment a) : StateVarView(m) {
!     TextInteractor* t = new TextInteractor(GRAVITY_ON, a);
      Insert(t);
  }
  
--- 319,343 ----
      char buf[32];
  
      _prevVal = mag;
+ #ifndef JIV_EXTEND
      sprintf(buf, "mag %gx", mag);
+ #else
+     sprintf(buf, "%s %gx", getLabel("LMagMark", "mag"), mag);
+ #endif
      t->SetText(buf);
  }
  
  /*****************************************************************************/
  
  GravityVarView::GravityVarView (GravityVar* m, Alignment a) : StateVarView(m) {
!     TextInteractor* t = new TextInteractor(
! #ifndef JIV_EXTEND
! 					   GRAVITY_ON,
! #else
! 					   getLabel("LGravityOnMark",
! 						    GRAVITY_ON),
! #endif
! 					   a);
      Insert(t);
  }
  
***************
*** 305,311 ****
  void GravityVarView::Init() {
      boolean active = ((GravityVar*) _subject)->IsActive();
      TextInteractor* t = (TextInteractor*) interior();
!     const char* string = active ? GRAVITY_ON : "";
  
      _prevVal = active;
      t->SetText(string);
--- 348,361 ----
  void GravityVarView::Init() {
      boolean active = ((GravityVar*) _subject)->IsActive();
      TextInteractor* t = (TextInteractor*) interior();
!     const char* string = active ?
! #ifndef JIV_EXTEND
! 			   GRAVITY_ON :
! #else
! 			   getLabel("LGravityOnMark",
! 				    GRAVITY_ON) :
! #endif
! 			   "";
  
      _prevVal = active;
      t->SetText(string);
***************
*** 411,417 ****
      Unref(tmp);
  
      const Font* f = output->GetFont();
!     shape->width = max(f->Width(NONE) + 2*HPAD, VIEW_WIDTH);
      shape->height = max(f->Height() + 2*VPAD, VIEW_HEIGHT);
  
      shape->Rigid(shape->width/2, shape->width, shape->height/2, shape->height);
--- 461,473 ----
      Unref(tmp);
  
      const Font* f = output->GetFont();
!     shape->width = max(f->Width(
! #ifndef JIV_EXTEND
! 				NONE
! #else
! 				getLabel("LNone", NONE)
! #endif
! 				) + 2*HPAD, VIEW_WIDTH);
      shape->height = max(f->Height() + 2*VPAD, VIEW_HEIGHT);
  
      shape->Rigid(shape->width/2, shape->width, shape->height/2, shape->height);
***************
*** 422,429 ****
--- 478,490 ----
  	output->ClearRect(canvas, 0, 0, xmax, ymax);
  
  	if (_brush->None()) {
+ #ifndef JIV_EXTEND
  	    CenterText(NONE, output, xmax, ymax);
  	    output->Text(canvas, NONE);
+ #else
+ 	    CenterText(getLabel("LNone", NONE), output, xmax, ymax);
+ 	    output->Text(canvas, getLabel("LNone", NONE));
+ #endif
  
  	} else {
              const Color* origfg = output->GetFgColor();
***************
*** 564,570 ****
      Unref(tmp);
  
      const Font* f = output->GetFont();
!     shape->width = max(f->Width(NONE) + 2*HPAD, VIEW_WIDTH);
      shape->height = max(f->Height() + 2*VPAD, VIEW_HEIGHT);
  
      shape->Rigid(shape->width/2, shape->width, shape->height/2, shape->height);
--- 625,637 ----
      Unref(tmp);
  
      const Font* f = output->GetFont();
!     shape->width = max(f->Width(
! #ifndef JIV_EXTEND
! 				NONE
! #else
! 				getLabel("LNone", NONE)
! #endif
! 				) + 2*HPAD, VIEW_WIDTH);
      shape->height = max(f->Height() + 2*VPAD, VIEW_HEIGHT);
  
      shape->Rigid(shape->width/2, shape->width, shape->height/2, shape->height);
***************
*** 575,582 ****
--- 642,654 ----
  	output->ClearRect(canvas, 0, 0, xmax, ymax);
  
  	if (_pattern->None()) {
+ #ifndef JIV_EXTEND
  	    CenterText(NONE, output, xmax, ymax);
  	    output->Text(canvas, NONE);
+ #else
+ 	    CenterText(getLabel("LNone", NONE), output, xmax, ymax);
+ 	    output->Text(canvas, getLabel("LNone", NONE));
+ #endif
  
  	} else {
              const Color* origfg = output->GetFgColor();
diff -cNr ivtools-0.6.orig/src/Unidraw/viewcmds.c ivtools-0.6/src/Unidraw/viewcmds.c
*** ivtools-0.6.orig/src/Unidraw/viewcmds.c	Fri Feb 28 08:41:47 1997
--- ivtools-0.6/src/Unidraw/viewcmds.c	Wed Jan 28 20:32:14 1998
***************
*** 32,43 ****
--- 32,55 ----
  #include <Unidraw/statevars.h>
  #include <Unidraw/unidraw.h>
  #include <Unidraw/viewer.h>
+ #ifdef JIV_EXTEND
+ #include <Unidraw/catalog.h>
+ #include <stdio.h>
+ #endif
  
  #include <Unidraw/Commands/catcmds.h>
  #include <Unidraw/Commands/viewcmds.h>
  
  #include <Unidraw/Components/component.h>
  
+ #ifdef JIV_EXTEND
+ static const char* tmpLabel;
+ 
+ #define getLabel(attr, default) \
+     (((tmpLabel = unidraw->GetCatalog()->GetAttribute(attr)) != NULL) ? \
+      tmpLabel : default)
+ #endif
+ 
  /*****************************************************************************/
  
  ClassId NormSizeCmd::GetClassId () { return NORMSIZE_CMD; }
***************
*** 298,304 ****
--- 310,320 ----
  	ModifStatusVar* mv = (ModifStatusVar*) ed->GetState("ModifStatusVar");
  
  	if (mv != nil && mv->GetModifStatus() && !FoundAnyExcept(ed)) {
+ #ifndef JIV_EXTEND
              ConfirmDialog dialog("Save changes?");
+ #else
+             ConfirmDialog dialog(getLabel("MEndConfirm", "Save changes?"));
+ #endif
  
  	    ed->InsertDialog(&dialog);
  	    char resp = dialog.Confirm();
diff -cNr ivtools-0.6.orig/src/drawserv/Imakefile ivtools-0.6/src/drawserv/Imakefile
*** ivtools-0.6.orig/src/drawserv/Imakefile	Wed Dec 24 02:54:25 1997
--- ivtools-0.6/src/drawserv/Imakefile	Fri Jan 30 00:22:57 1998
***************
*** 38,44 ****
  
  Use_libUnidraw()
  Use_2_6()
! ComplexProgramTargetNoInstall(drawserv)
  
  #define Obj(file) MakeObjectFromSrcFlags(file,-xc++ -D__ACE_INLINE__)
  
--- 38,45 ----
  
  Use_libUnidraw()
  Use_2_6()
! XCOMM ComplexProgramTargetNoInstall(drawserv)
! ComplexProgramTarget(drawserv)
  
  #define Obj(file) MakeObjectFromSrcFlags(file,-xc++ -D__ACE_INLINE__)
  
diff -cNr ivtools-0.6.orig/src/idraw/main.c ivtools-0.6/src/idraw/main.c
*** ivtools-0.6.orig/src/idraw/main.c	Fri Feb 28 08:41:54 1997
--- ivtools-0.6/src/idraw/main.c	Wed Jan 28 20:32:09 1998
***************
*** 46,53 ****
--- 46,58 ----
      { "*initialfont",   "4" },
      { "*initialpattern","1" },
      { "*initialarrow", "none" },
+ #ifndef JIV_EXTEND
      { "*pagewidth", "8.5" },
      { "*pageheight", "11" },
+ #else
+     { "*pagewidth", "8.27" },
+     { "*pageheight", "11.69" },
+ #endif
      { "*gridxincr", "8" },
      { "*gridyincr", "8" },
      { "*font1", "-*-courier-medium-r-normal-*-8-*-*-*-*-*-*-* Courier 8" },
diff -cNr ivtools-0.6.orig/src/include/IV-2_6/InterViews/box.h ivtools-0.6/src/include/IV-2_6/InterViews/box.h
*** ivtools-0.6.orig/src/include/IV-2_6/InterViews/box.h	Fri Feb 28 08:41:56 1997
--- ivtools-0.6/src/include/IV-2_6/InterViews/box.h	Wed Jan 28 20:32:09 1998
***************
*** 33,38 ****
--- 33,44 ----
  
  #include <IV-2_6/_enter.h>
  
+ #ifdef USE_SUNCxx2
+ # undef	major
+ # undef	minor
+ #endif USE_SUNCxx2
+ 
+ 
  class BoxElement;
  class BoxCanonical;
  
diff -cNr ivtools-0.6.orig/src/include/IV-2_6/InterViews/interactor.h ivtools-0.6/src/include/IV-2_6/InterViews/interactor.h
*** ivtools-0.6.orig/src/include/IV-2_6/InterViews/interactor.h	Fri Feb 28 08:41:57 1997
--- ivtools-0.6/src/include/IV-2_6/InterViews/interactor.h	Wed Jan 28 20:32:09 1998
***************
*** 54,59 ****
--- 54,62 ----
  class Style;
  class Window;
  class World;
+ #ifdef JIV			/* eto@ai.cs.fujitsu.co.jp 12 Jan 1992 */
+ class ClientMessageHandler;
+ #endif /* JIV */
  
  enum CanvasType {
      CanvasShapeOnly, CanvasInputOnly, CanvasInputOutput,
***************
*** 108,113 ****
--- 111,120 ----
      void Run();
      void QuitRunning(Event&);
      virtual void Handle(Event&);
+ #ifdef JIV			/* eto@ai.cs.fujitsu.co.jp 12 Jan 1992 */
+     void SetClientMessageHandler(ClientMessageHandler*);
+     void ResetClientMessageHandler(ClientMessageHandler*);
+ #endif /* JIV */
  
      /* subject-view communication */
      virtual void Adjust(Perspective&);
***************
*** 169,174 ****
--- 176,185 ----
      void DoConfig(boolean);
  
      virtual void Orphan();
+ 
+ #ifdef JIV			/* eto@ai.cs.fujitsu.co.jp 12 Jan 1992 */
+     ClientMessageHandler* cmhandler;
+ #endif
  };
  
  inline Scene* Interactor::Parent() const { return parent; }
diff -cNr ivtools-0.6.orig/src/include/IV-2_6/InterViews/painter.h ivtools-0.6/src/include/IV-2_6/InterViews/painter.h
*** ivtools-0.6.orig/src/include/IV-2_6/InterViews/painter.h	Tue Dec  2 11:02:16 1997
--- ivtools-0.6/src/include/IV-2_6/InterViews/painter.h	Wed Jan 28 20:32:09 1998
***************
*** 161,166 ****
--- 161,169 ----
  	Canvas* src, Coord x1, Coord y1, Coord x2, Coord y2,
  	Canvas* dst, Coord x0, Coord y0
      );
+ #ifdef JIV
+     virtual void MapCoord(Canvas*, Coord x, Coord y, Coord& nx, Coord& ny);
+ #endif	/* JIV */
  
      PainterRep* Rep() const;
  private:
diff -cNr ivtools-0.6.orig/src/include/IV-2_6/InterViews/textdisplay.h ivtools-0.6/src/include/IV-2_6/InterViews/textdisplay.h
*** ivtools-0.6.orig/src/include/IV-2_6/InterViews/textdisplay.h	Fri Feb 28 08:41:57 1997
--- ivtools-0.6/src/include/IV-2_6/InterViews/textdisplay.h	Wed Jan 28 20:32:09 1998
***************
*** 86,91 ****
--- 86,96 ----
      IntCoord Top(int line);
      IntCoord Left(int line, int index);
      IntCoord Right(int line, int index);
+ 
+ #ifdef JIV
+     void TextDisplay::CaretPoint(int&, int&);
+ #endif	/* JIV */
+ 
  private:
  friend class TextLine;
  
diff -cNr ivtools-0.6.orig/src/include/IV-X11/xjivfunc.h ivtools-0.6/src/include/IV-X11/xjivfunc.h
*** ivtools-0.6.orig/src/include/IV-X11/xjivfunc.h	Thu Jan  1 09:00:00 1970
--- ivtools-0.6/src/include/IV-X11/xjivfunc.h	Wed Jan 28 20:32:09 1998
***************
*** 0 ****
--- 1,38 ----
+ /*
+  * Copyright (c) 1991, 1992 Fujitsu Oita Software Laboratory Limited
+  *
+  * Permission to use, copy, modify, and distribute this software and its
+  * documentation for any purpose is hereby granted without fee, provided
+  * that the above copyright notice and this permission notice appear in
+  * all copies of the software and related documentation, and the name of
+  * Fujitsu Oita Software Laboratory may not be used in any advertising or
+  * publicity relating to the software without specific, prior written
+  * prior permission of Fujitsu Oita Software Laboratory. 
+  * 
+  * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
+  * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
+  * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
+  *
+  * IN NO EVENT SHALL FUJITSU OITA SOFTWARE LABORATORY BE LIABLE FOR ANY
+  * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR
+  * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
+  * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY
+  * OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+  * PERFORMANCE OF THIS SOFTWARE.
+  *
+  * Author:  Toshihisa Eto, Fujitsu Oita Software Laboratory Limited, Japan
+  * 	E-Mail: eto@ai.cs.fujitsu.co.jp
+  * 	Nifty:	HBG02665
+  */
+ 
+ #ifdef JIV
+ extern short JIVGetLeftBearing(const char*, int, FontRep*, FontRep*);
+ extern short JIVGetRightBearing(const char*, int, FontRep*, FontRep*);
+ extern short JIVGetWidth(const char*, int, FontRep*, FontRep*);
+ extern short JIVGetAscent(const char*, int, FontRep*, FontRep*);
+ extern short JIVGetDescent(const char*, int, FontRep*, FontRep*);
+ extern void JIVDrawString(XDisplay*, XDrawable, GC, const Font*,
+ 		   int, int, unsigned char*, int, Display*);
+ extern void JIVDrawImageString(XDisplay *, XDrawable, GC, const Font*,
+ 			       int, int, unsigned char*, int, Display*);
+ #endif /* JIV */
diff -cNr ivtools-0.6.orig/src/include/InterViews/clthandler.h ivtools-0.6/src/include/InterViews/clthandler.h
*** ivtools-0.6.orig/src/include/InterViews/clthandler.h	Thu Jan  1 09:00:00 1970
--- ivtools-0.6/src/include/InterViews/clthandler.h	Wed Jan 28 20:32:09 1998
***************
*** 0 ****
--- 1,55 ----
+ /*
+  * Copyright (c) 1991, 1992 Fujitsu Oita Software Laboratory Limited
+  *
+  * Permission to use, copy, modify, and distribute this software and its
+  * documentation for any purpose is hereby granted without fee, provided
+  * that the above copyright notice and this permission notice appear in
+  * all copies of the software and related documentation, and the name of
+  * Fujitsu Oita Software Laboratory may not be used in any advertising or
+  * publicity relating to the software without specific, prior written
+  * prior permission of Fujitsu Oita Software Laboratory. 
+  * 
+  * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
+  * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
+  * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
+  *
+  * IN NO EVENT SHALL FUJITSU OITA SOFTWARE LABORATORY BE LIABLE FOR ANY
+  * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR
+  * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
+  * WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY
+  * OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+  * PERFORMANCE OF THIS SOFTWARE.
+  *
+  * Author:  Toshihisa Eto, Fujitsu Oita Software Laboratory Limited, Japan
+  * 	E-Mail: eto@ai.cs.fujitsu.co.jp
+  * 	Nifty:	HBG02665
+  */
+ 
+ #ifdef JIV
+ 
+ #ifndef iv_clthandler_h
+ #define iv_clthandler_h
+ 
+ #include <InterViews/boolean.h>
+ #include <InterViews/handler.h>
+ 
+ #include <InterViews/_enter.h>
+ 
+ class Event;
+ 
+ class ClientMessageHandler : public Handler {
+ protected:
+     ClientMessageHandler();
+ public:
+     virtual ~ClientMessageHandler();
+ 
+     virtual boolean event(Event&) = 0;
+ 
+     virtual boolean handle_p(const Event&);
+ };
+ 
+ #include <InterViews/_leave.h>
+ 
+ #endif
+ 
+ #endif	/* JIV */
diff -cNr ivtools-0.6.orig/src/include/InterViews/event.h ivtools-0.6/src/include/InterViews/event.h
*** ivtools-0.6.orig/src/include/InterViews/event.h	Fri Feb 28 08:42:03 1997
--- ivtools-0.6/src/include/InterViews/event.h	Wed Jan 28 20:32:10 1998
***************
*** 52,58 ****
--- 52,65 ----
      EnterEvent,		/* mouse enters canvas */
      LeaveEvent,		/* mouse leaves canvas */
      FocusInEvent,	/* focus for keyboard events */
+ #ifndef JIV			/* patch by eto@ai.cs.fujitsu.co.jp */
      FocusOutEvent 	/* lose keyboard focus */
+ #else /* JIV */
+     FocusOutEvent, 	/* lose keyboard focus */
+     ClientEvent,	/* message from other client */
+     PropertyEvent, 	/* get property change */
+     NullEvent		/* init value for Event::eventType */
+ #endif /* JIV */		/* patch end */
  };
  
  /* mouse button anachronisms */
***************
*** 62,68 ****
--- 69,79 ----
  
  class Event {
  public:
+ #ifndef JIV			/* patch by eto@ai.cs.fujitsu.co.jp */
      enum { undefined, motion, down, up, key, other_event };
+ #else	/* JIV */
+     enum { undefined, motion, down, up, key, property, other_event };
+ #endif	/* JIV */		/* patch end */
      enum { none, any, left, middle, right, other_button };
  
      Event();
